/*
    Event handlers

    Changelog:
    
    15.5.2016: Key and mouse events cause repainting the screen
    3.5.2016: Shift status
    29.4.2016: Shortcut key "f" for force
    27.4.2016: Shortcut key "z" for zoom
    27.4.2016: Shortcut key "g" for the grid
    27.4.2016: The first version
*/

boolean shift=false;

void mouseClicked()
{
    machine.handleclicks();
    repaint=true;
}

void mousePressed()
{
    repaint=true;
}

void keyPressed()
{
    if(keyCode==SHIFT)
        shift=true;
    
    if(key=='c') // Check
    {
        machine.colorcorrect();
        machine.check(false);
    }
    if(key=='r') // Revert
    {
        machine.colorcorrect();
    }
    if(key=='f') // Force
    {
        machine.colorcorrect();
        machine.check(true);
    }
    if(key=='g') // Grid toggle
    {
        machine.grid=!machine.grid;
        machine.grid_b.checked=machine.grid;
    }
    if(key=='z') // Zoom toggle
    {
        machine.zoom=!machine.zoom;
        machine.zoom_b.checked=machine.zoom;
    }
    
    if(key==ESC) // Let's NOT quit
        key=0;
        
    repaint=true;
}

void keyReleased()
{
    if(keyCode==SHIFT)
        shift=false;
        
    repaint=true;
}
