/*
    Some Java trash for file selectors etc.

    Changelog:
    
    3.5.2016: Turned selector() vertical and improved centering
    2.5.2016: Added menuselector()
    28.4.2016: UIManager things belong rather here
    26.4.2016: The first version
*/

import java.awt.event.*;
import java.awt.Dimension;
import java.awt.GridLayout;
import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;

void genericjavatheme()
{
    try
    {
        UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
    }
    catch (Exception e) {};
}

class Selector extends JPanel implements ActionListener
{
    int selection;
    protected JButton b[];
    
    Selector(String s) // Split string into options
    {
        String splitz[]=splitTokens(s,",");
        b=new JButton[splitz.length];
        
        setLayout(new GridLayout(splitz.length,1,1,1));
        
        for(int i=0;i<splitz.length;i++)
        {
            b[i]=new JButton(splitz[i]);
            b[i].setActionCommand(str(i+'0'));
            b[i].addActionListener(this);
            b[i].setHorizontalAlignment(SwingConstants.LEFT);
            
            add(b[i]);
        }
        
        selection=-1;
    }
    public void actionPerformed(ActionEvent e)
    {
        for(int i=0;i<b.length;i++)
        {
            if(str(i+'0').equals(e.getActionCommand()))
                selection=i;
        }
    }
}

// Select from a list
int selector(String title,String opt)
{
    JFrame frame=new JFrame(title);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setLocationRelativeTo(null);
    
    Selector s=new Selector(opt);
    s.setOpaque(true);
    frame.setContentPane(s);
 
    //Display the window.
    frame.pack();
    frame.setVisible(true);
    
    frame.setLocationRelativeTo(null); // About in the middle
    
    while(s.selection==-1)
    {
        frame.toFront(); // A bit of a kludge to force the window on top
        frame.repaint();
        try { Thread.sleep(200); }
        catch(Exception e){};
    }
    
    frame.setVisible(false);
    
    System.gc(); // It'll leak anyway...
    return(s.selection);
}

// Select an option from a list
int menuselector(String title,String menutitle,String choices[])
{ 
    String input=(String)JOptionPane.showInputDialog(null,menutitle,title,JOptionPane.QUESTION_MESSAGE,
                                                     null,choices,choices[0]);
                                           
    if(input==null)
        return -1;
    else
    {
        for(int i=0;i<choices.length;i++)
            if(input.equals(choices[i]))
                return i;
    }
    return -1;
}

final int LOAD=0,
          SAVE=1;

// File selector
String fileselector(String dir,String filtername,String filter[],int mode)
{
    JFileChooser fc=new JFileChooser(dir);
    
    fc.setPreferredSize(new Dimension(480, 500));
    fc.setDialogTitle("Select a File");
    
    fc.setFileFilter(new FileNameExtensionFilter(filtername,filter));
    
    if(mode==LOAD)
        fc.setApproveButtonText("Load");
    else
        fc.setApproveButtonText("Save");
    
    int returnVal = fc.showOpenDialog(this);
    
    if(returnVal==JFileChooser.APPROVE_OPTION)
    {
        // Save cwd for next time
        prefs.path=fc.getCurrentDirectory().getPath();
        
        File file = fc.getSelectedFile();
        return file.getPath();
    }
    else
        return null;
}
