/*
    A class for simple UI buttons

    Changelog:
    
    27.4.2016: A bit smaller checkboxes
    27.4.2016: Added class Checkbutton
    26.4.2016: The first version
*/

ArrayList<Button> butts=new ArrayList();

class Button
{
    int x,y,w,h,next;
    
    String text;
    
    Button() {};
    
    Button(int px,int py,String txt)
    {
        x=px;
        y=py;
        next=py+prefs.UIROW;
        w=prefs.UIWIDTH-prefs.BWIDTH*2;
        h=20;

        text=txt;
        
        butts.add(this);
    }
    
    void draw()
    {
        if(mouseover())
            stroke(160);
        else
            stroke(prefs.UITEXT);
        fill(#546070);
        rect(x,y,w,h,3,3,3,3);
        fill(prefs.UITEXT);
        textAlign(CENTER);
        text(text,x+w/2,y+16);
        textAlign(LEFT);
        noStroke();
    }
    
    boolean mouseover()
    {
        if(mouseX>x && mouseY>y && mouseX<=x+w && mouseY<=y+20)
            return true;
        else
            return false;        
    }
}

// A bit different
class Checkbutton extends Button
{
    boolean checked=false;
    
    Checkbutton(int px,int py,String txt)
    {
        x=px;
        y=py+2;
        next=py+prefs.UIROW;
        w=16;
        h=16;

        text=txt;
        
        butts.add(this);
    }
    
    void draw()
    {
        if(mouseover())
            stroke(160);
        else
            stroke(prefs.UITEXT);
        fill(#546070);
        rect(x,y,w,h,3,3,3,3);
        fill(prefs.UITEXT);
        text(text,x+w+5,y+14);
        
        if(checked)
        {
            stroke(210);
            line(x+4,y+4, x+w-4,y+h-4);
            line(x+w-4,y+4, x+4,y+h-4);
        }
        noStroke();
    }
}

void drawbuttons()
{
    for(int i=0;i<butts.size();i++)
        butts.get(i).draw();
}
